package com.application.GUI;

import com.application.DB.DB;
import javafx.scene.chart.CategoryAxis;
import javafx.scene.chart.LineChart;
import javafx.scene.chart.NumberAxis;
import javafx.scene.chart.XYChart;

import java.util.Map;

public class LineChartFunctionality {

    private static LineChart<String, Number> lineChart;
    private static XYChart.Series<String, Number> series;
    private static XYChart.Data<String, Number> chartData;
    private static CategoryAxis xAxis;
    private static NumberAxis yAxis;


    public LineChartFunctionality(){
        xAxis = new CategoryAxis();
        yAxis = new NumberAxis();
        series = new XYChart.Series<String, Number>();
        chartData = new XYChart.Data<String, Number>();
        lineChart = new LineChart<>(xAxis,yAxis);
        xAxis.setLabel("Date");
        yAxis.setLabel("Kwh");
        lineChart.setTitle("Drying Processes");
    }

    public LineChart<String, Number> getLineChart() {
        return lineChart;
    }

    public static XYChart.Series<String, Number> getSeries() {
        return series;
    }

    public static void updateLineChart(XYChart.Series<String, Number> series){
        lineChart.getData().add(series);
    }

    public static void clearLineChart(){
        lineChart.getData().clear();
    }


    public static void loadSingleSeries() throws Exception {
        clearLineChart();

        Map<Integer, Map<String, Number>> kWh = DB.setInputParameters();
        //System.out.println(kWh.size());

        for (Map.Entry<Integer, Map<String, Number>> entryKwh : kWh.entrySet()) {
            Map data = entryKwh.getValue();
            //System.out.println(data.size());

            XYChart.Series<String, Number> newSeries = new XYChart.Series<String, Number>();
            int index = 0;
            for (Object entryData : data.entrySet()) {
                //System.out.println("data: \t"+entryData);
                String entryString = entryData.toString();
                String[] arr = entryString.split("=");
                String date = arr[0];
                int kwhValue = Integer.parseInt(arr[1]);

                //System.out.printf("Date: \t%s\t\t\tkWh: \t%s\n",date,kwhValue);


                // Connect the data to a series
                newSeries.getData().add(new XYChart.Data<String, Number>(String.valueOf(index), kwhValue));
                index += 1;
            }
            updateLineChart(newSeries);
        }
    }

    public static void loadMultipleSeries() throws Exception {

        Map<Integer, Map<String, Number>> kWh = DB.setInputParameters();
        //System.out.println(kWh.size());

        for (Map.Entry<Integer, Map<String, Number>> entryKwh : kWh.entrySet()) {
            Map data = entryKwh.getValue();
            //System.out.println(data.size());

            XYChart.Series<String, Number> newSeries = new XYChart.Series<String, Number>();
            for (Object entryData : data.entrySet()){
                //System.out.println("data: \t"+entryData);
                String entryString = entryData.toString();
                String[] arr = entryString.split("=");
                String date = arr[0];
                int kwhValue = Integer.parseInt(arr[1]);

                //System.out.printf("Date: \t%s\t\t\tkWh: \t%s\n",date,kwhValue);


                // Connect the data to a series
                newSeries.getData().add(new XYChart.Data<String, Number>(date,kwhValue));

            }
            updateLineChart(newSeries);
        }


/*
        for (Map.Entry<Integer, Map> entryKwh : kWh.entrySet()) {
            System.out.printf("Index: \t%s\t\t\tkWh: \t%s\n",entryKwh.getKey(),entryKwh.getValue());
        }
 */
    }

}
